var slickPosToLayoutName = ['0', '1', '2', '3', '11', '12', '4', '5', '6', '7', '8', '13', '9', '10'];
var arrSuggestion = [];

var propertiesResponse = null;

$(document).ready(function() {

  initTooltips();
  initVideoChannel();
  initServiceId();

  const textType = '#weatherTextType';

  // Change font select (file manager) after close modal
  $('body').off('hide.bs.modal').on('hide.bs.modal', '#fileManagerModal', function() {
    createFontList(textType, serviceArrTmp[activeItem].font);
  });

  $('#weatherLocationName').on('change',function(){
    validate($(this),'','Enter a city name.');
  });

  $('#weatherLocationName').typeahead({
    source: getLocationDataToSuggest,
    updater: function(item){
      city = item.split(',');
      administrativeArea = city[1].trim();
      for (var i = 0; i < arrSuggestion.length; i++) {
        if(arrSuggestion[i].LocalizedName === city[0] && arrSuggestion[i].AdministrativeArea.LocalizedName === administrativeArea) {
          serviceArrTmp[activeItem].location = arrSuggestion[i].Key;
          serviceArrTmp[activeItem].locationName = arrSuggestion[i].LocalizedName;
          renderMap();
          return arrSuggestion[i].LocalizedName;
        }
      }
    },
    items: 'all'
  });

  $('.chooseBgColor').on('click',function(){
    $('.chooseBgColor').css('border-color','transparent');
    var colorValueOfButtonStart = $(this).attr('data-value-start');
    var colorValueOfButtonEnd = $(this).attr('data-value-end');
    $('.chooseBgColor[data-value-start="'+colorValueOfButtonStart+'"]').css('border-color', '#508cff');
    $('#bgStartColor').val(colorValueOfButtonStart);
    $('#bgEndColor').val(colorValueOfButtonEnd);
    return false;
  });

  $('#weatherLayout').slick({
    centerMode: true,
    centerPadding: '60px',
    slidesToShow: 1,
    variableWidth: true,
    draggable: false
  });

  // Fill form
  Switch().init('weatherEnabled');

  $('#weatherCustomName')
    .val(serviceArrTmp[activeItem].customName || '')
    .keyup(onCustomNameKeyUp)
    .attachValidation({
      pattern: '^[A-Za-z0-9 -]{0,}$',
      invalidMsg: 'Only chars A-Z, a-z, 0-9, white space and dash are allowed.',
      disableBtnId: 'saveBtn'
    });
  $('#weatherLocationName').val(serviceArrTmp[activeItem].locationName);
  $('#weatherTitle').val(serviceArrTmp[activeItem].title != undefined ? serviceArrTmp[activeItem].title : '');
  if (serviceArrTmp[activeItem].clockType != undefined) {
    $('#weatherRadioClock').val(serviceArrTmp[activeItem].clockType).change();
  }
  $('#bgStartColor').val(serviceArrTmp[activeItem].bgStartColor);
  $('#bgEndColor').val(serviceArrTmp[activeItem].bgEndColor);
  var bgStartColor = $('#bgStartColor').val();
  $('.chooseBgColor[data-value-start="'+bgStartColor+'"]').css('border-color', '#508cff');

  const languageVal = serviceArrTmp[activeItem].lang;
  $('#weatherLanguage').val(languageVal);
  createFontListOptions(textType).then(function() {
    $(textType).val(serviceArrTmp[activeItem].font);
  });

  $('#weatherUnits').val(serviceArrTmp[activeItem].units);
  $('#weatherOffsetX').val(serviceArrTmp[activeItem].pos_x);
  $('#weatherOffsetY').val(serviceArrTmp[activeItem].pos_y);
  $('#weatherScale').val(serviceArrTmp[activeItem].scale * 100);

  // Find slick position
  for(var i = 0; i < slickPosToLayoutName.length; i++) {
    if (slickPosToLayoutName[i] == serviceArrTmp[activeItem].layout) {
      $('#weatherLayout').slick('slickGoTo', i);
      break;
    }
  }

  // Validate lcoation after form is filled
  validate($('#weatherLocationName'), '', 'Enter a city name.');

  const resolutionId = '#weatherResolution';
  const videoChannelId = '#weatherVideoChannel';
  createResolutionList(resolutionId);
  onResolutionChange(resolutionId, videoChannelId);
  createPositionList('#weatherPosition', serviceArrTmp[activeItem].coordSystem);
  createTriggeringElement('#weatherAutomationType', serviceArrTmp[activeItem].automationType, serviceArrTmp[activeItem].schedule);
  onVideoChannelChange(resolutionId, videoChannelId, serviceArrTmp[activeItem].camera);
  createVideoChannelElement(videoChannelId, serviceArrTmp[activeItem].camera).then(function(){
    // Callbacks for changes
    $('.chooseBgColor').on('click',formChangedCallback); //div with color onclick
    $('#weatherLocationName').on('change', formChangedCallback());
    $('.form-control').change(formChangedCallback);
    $('.form-control-inline').change(formChangedCallback);
    $('#weatherLayout').on('beforeChange', layoutChangedCallback);
    $('.layoutItem').click(layoutClickedCallback);
    $('.fontManagerBtn').click(showFontManagerCallback);

    formChangedCallback();

    let currentCameraResolutionObject = cameraResolutions[parseInt($('#weatherResolution').val())];
    createCameraPreview($('#weatherVideoChannel'), currentCameraResolutionObject, serviceArrTmp[activeItem].camera);
  });

  createScheduleBtn();

});

async function formChangedCallback() {

  serviceArrTmp[activeItem].customName = $('#weatherCustomName').val();
  serviceArrTmp[activeItem].title = $('#weatherTitle').val();
  serviceArrTmp[activeItem].clockType = $('#weatherRadioClock').val();
  serviceArrTmp[activeItem].lang = $('#weatherLanguage').val();
  serviceArrTmp[activeItem].font = $('#weatherTextType').val();
  serviceArrTmp[activeItem].bgStartColor =  $('#bgStartColor').val();
  serviceArrTmp[activeItem].bgEndColor =  $('#bgEndColor').val();
  serviceArrTmp[activeItem].locationName = $('#weatherLocationName').val();
  serviceArrTmp[activeItem].units = $('#weatherUnits').val();
  let currentCameraResolutionObject = cameraResolutions[parseInt($('#weatherResolution').val())];
  serviceArrTmp[activeItem].width = currentCameraResolutionObject.width;
  serviceArrTmp[activeItem].height = currentCameraResolutionObject.height;
  serviceArrTmp[activeItem].coordSystem = $('#weatherPosition').val();
  serviceArrTmp[activeItem].automationType = $('#weatherAutomationType').val();
  serviceArrTmp[activeItem].pos_x = parseInt($('#weatherOffsetX').val());
  serviceArrTmp[activeItem].pos_y = parseInt($('#weatherOffsetY').val());
  serviceArrTmp[activeItem].scale = parseFloat($('#weatherScale').val()) / 100;

  serviceArrTmp[activeItem].camera = saveVideoChannelValue(serviceArrTmp[activeItem].camera, $('#weatherVideoChannel'));

  showSaveWarning();
  createServiceList(serviceArrTmp);
}

function layoutChangedCallback(event, slick, currentSlide, nextSlide) {
  serviceArrTmp[activeItem].layout = slickPosToLayoutName[nextSlide];
  showSaveWarning();
}

/**
 * Create HTML options for select
 * @param {string} jquerySelector
 * @returns {Promise<void>}
 */
async function createFontListOptions(jquerySelector) {
  let fontList = await fontManager.getFileList();
  $(jquerySelector)
    .empty()
    .append(new Option('Default', '', false, false));

  fontList.forEach(item => {
    $(jquerySelector).append(new Option(item.name, item.path.replace('file://', ''), false, false));
  });
}

function layoutClickedCallback(event) {
  var targ = event.target || event.srcElement;
  var item = $(targ).closest('.layoutItem');
  var current = $('#weatherLayout').slick('slickCurrentSlide');
  var newPos = item.attr('data-slick-index');
  if (current == newPos)
    return;

  if (current < newPos)
    $('#weatherLayout').slick('slickNext');
  else
    $('#weatherLayout').slick('slickPrev');
}

function getLocationDataToSuggest(query, result) {

  var lang = serviceArrTmp[activeItem].lang;
  while(arrSuggestion.length > 0) {
    arrSuggestion.pop();
  }
  $.ajax({
    url: serverUrl + '/index.php?p=CamOverlay&a=AccuWeatherProxy&serial_number=' + serialNumber + '&q='+ encodeURIComponent('/locations/v1/cities/autocomplete?q=' + encodeURIComponent(query) + '&language='+encodeURIComponent(lang)),
    dataType: "json",
    type: "GET",
    success: function (data) {
      result($.map(data, function (item) {
        arrSuggestion.push(item);
        return item.LocalizedName + ", " + item.AdministrativeArea.LocalizedName  +  ", " + item.Country.LocalizedName;
      }));
    }
  });
}

