function Switch() {

  let element = null;
  let toggle = null;

  /**
   * Render html container with input
   * @returns {Promise<void>}
   */
  let render = async () => {
    const label_html = document.createElement('label');
    label_html.className = 'switch';
    const span_html = document.createElement('span');
    span_html.className = 'slider round';
    label_html.appendChild(span_html);
    element.appendChild(label_html);
  }

  /**
   * @param {boolean} value
   */
  let setValue = async (value) => {
    toggle.setAttribute('checked', Boolean(value));
    serviceArrTmp[activeItem].enabled = value ? 1 : 0;
    serviceArr[activeItem].enabled = value ? 1 : 0
    createServiceList(serviceArrTmp);
    await saveBtnCallback(true, serviceArr);
  }

  /**
   * @param {string} element_id
   * @returns {Promise<void>}
   */
  let init = async (element_id) => {

    element = document.getElementById(element_id);
    await render();

    toggle = element.getElementsByTagName('label')[0];
    toggle.removeEventListener('click', () => {});
    toggle.addEventListener('click', async () => {
      const origin_value = parseBool(toggle.getAttribute('checked'));
      let value = !origin_value;
      if (!origin_value) {
        const allow_turn_on = await configurationTmp.canEnableAnotherService();
        if (!allow_turn_on) {
          const alert_message = await configurationTmp.getMaxAllowedMessage();
          showMessage('warning', alert_message, false, 'maxAllowedServices');
          value = false;
        }
      }
      await setValue(value);
    });

    const init_allow_turn_on = await configurationTmp.exceedsMaxServiceCount();
    let init_origin_value = Boolean(serviceArrTmp[activeItem].enabled);
    if (init_allow_turn_on) {
      const init_alert_message = await configurationTmp.getMaxAllowedMessage();
      showMessage('warning', init_alert_message, false, 'maxAllowedServices');
      init_origin_value = false;
    }
    await setValue(init_origin_value);
  }

  return {
    init,
  }
}