function FontManager() {
  const font_options = {
    identifier: 'font',
    modalTitle: 'Font Manager',
    api: {
      getStorageUrl: '/local/camoverlay/api/upload_font.cgi?action=get_storage',
      listUrl: '/local/camoverlay/api/upload_font.cgi?action=list',
      uploadUrl: '/local/camoverlay/api/upload_font.cgi?action=upload',
      removeUrl: '/local/camoverlay/api/upload_font.cgi?action=remove',
    },
    listFileContainerWith: 'col-lg-12',
    filesAllowedTypes: ['ttf'],
    messages: {
      storageInfo: {
        flash: 'Fonts will be saved in camera internal memory. %ALLOWED_FILES%',
        SD0: 'Fonts will be saved on SD card inserted in camera. %ALLOWED_FILES%',
      },
      emptyRow: 'No fonts uploaded.',
      filesAllowed: 'Only TTF is allowed.',
      labelFileInputTooltip: 'Select the suitable storage. „Internal Memory“ = internal camera storage, „SD card“ = edge camera storage,' +
        ' „URL“ = links to external servers or directories.',
    },
  }

  /**
   * @param {string} removed_file_path
   */
  font_options.onAfterRemoveFile = function (removed_file_path) {
    if (removed_file_path.indexOf('.ttf') > -1) {
      let newArr = JSON.stringify(serviceArrTmp);
      let filePath = removed_file_path.replace('file://','');
      newArr = newArr.replaceAll(filePath, 'classic');
      serviceArrTmp = JSON.parse(newArr);
    }
  }

  font_options.onAfterStorageChanged = function() {
    $('#warningForImageManager').hide();
  }

  font_options.onAfterCreateFileList = function() {
    $('#fileListImagePreview').hide().empty();
  }

  font_options.showGalleryAlert = function() {};

  return FileManager(app_name, font_options);
}