function VideoElement(service_id, container) {
  let videoEl;
  let videoId;

  let get = () => videoEl;

  let create = async (media_stream) => {
    return new Promise((resolve) => {
      const video_html = $('<video class="videoSourceElement img-fluid rounded" autoplay></video>');
      const video_container_html = $('<div class="container_videoSourceElement"></div>');
      videoId = 'videoSource' + service_id;
      containerVideoId = 'container_'+videoId;
      video_html.attr('id', videoId);
      video_container_html.attr('id', containerVideoId);
      if (existsInContainer(container, containerVideoId)) {
        appendToContainer(container, video_container_html);
        if (existsInContainer(video_container_html, videoId)) {
          appendToContainer(video_container_html, video_html);
        }
      }
      videoEl = $('#' + videoId)[0];
      videoEl.srcObject = media_stream;
      resolve();
    });
  }
  
  let existsInContainer = (container, videoId) => container.find('#' + videoId).length === 0;
  let appendToContainer = (container, html_element)  => container.append(html_element);
  let onLoadedData = (callback) => $(videoEl).off('loadeddata').on('loadeddata', callback);

  let remove = () => { $(videoEl).closest('.container_videoSourceElement').remove(); }
  let play = () => { videoEl.play(); }
  let pause = () => { videoEl.pause(); }
  let stop = () => { videoEl.stop(); }

  return {
    get,
    create,
    play,
    pause,
    stop,
    remove,
    onLoadedData,
  }
}