$(document).ready(async function() {

  initTooltips();
  initVideoChannel();
  initServiceId();

  // Fill form
  Switch().init('sportzcastEnabled');

  $('#sportzcastCustomName')
    .val(serviceArrTmp[activeItem].customName || '')
    .keyup(onCustomNameKeyUp)
    .attachValidation({
      pattern: '^[A-Za-z0-9 -]{0,}$',
      invalidMsg: 'Only chars A-Z, a-z, 0-9, white space and dash are allowed.',
      disableBtnId: 'saveBtn'
    });
  $('#sportzcastUrl').val(serviceArrTmp[activeItem].xml_url);

  const resolutionId = '#sportzcastResolution';
  const videoChannelId = '#sportzcastVideoChannel';
  createResolutionList(resolutionId);
  onResolutionChange(resolutionId, videoChannelId);
  createTriggeringElement('#sportzcastAutomationType', serviceArrTmp[activeItem].automationType, serviceArrTmp[activeItem].schedule);
  await createVideoChannelElement(videoChannelId, serviceArrTmp[activeItem].camera);

  // Callbacks for changes
  $('.form-control').change(formChangedCallback);
  formChangedCallback();
  createScheduleBtn();

  let currentCameraResolutionObject = cameraResolutions[parseInt($('#sportzcastResolution').val())];
  createCameraPreview($('#sportzcastVideoChannel'), currentCameraResolutionObject, serviceArrTmp[activeItem].camera);
});

function formChangedCallback() {

  serviceArrTmp[activeItem].customName = $('#sportzcastCustomName').val();
  serviceArrTmp[activeItem].xml_url = $('#sportzcastUrl').val();
  serviceArrTmp[activeItem].automationType = $('#sportzcastAutomationType').val();
  serviceArrTmp[activeItem].camera = saveVideoChannelValue(serviceArrTmp[activeItem].camera, $('#sportzcastVideoChannel'));

  showSaveWarning();
  createServiceList(serviceArrTmp);
}